from unicon.plugins.generic.settings import GenericSettings

class NxosSettings(GenericSettings):

    def __init__(self):
        super().__init__()
        self.HA_INIT_EXEC_COMMANDS = [
            'term length 0',
            'term width 511',
            'terminal session-timeout 0'
        ]
        self.HA_INIT_CONFIG_COMMANDS = [
            'no logging console',
            'line console',
            'exec-timeout 0',
            'line vty',
            'exec-timeout 0',
            'terminal width 511'
        ]
        self.SWITCHOVER_TIMEOUT = 700
        self.SWITCHOVER_COUNTER = 50
        self.HA_RELOAD_TIMEOUT = 700
        self.RELOAD_TIMEOUT = 400
        self.RELOAD_RECONNECT_WAIT = 60
        self.CONSOLE_TIMEOUT = 30
        self.GUESTSHELL_RETRIES = 20
        self.GUESTSHELL_RETRY_SLEEP = 5
        self.ATTACH_CONSOLE_DISABLE_SLEEP = 250
        self.ERROR_PATTERN = [
            r'^%\s*[Ii]nvalid (command|input|number)',
            r'^%\s*[Ii]ncomplete (command|input)',
            r'^%\s*[Aa]mbiguous (command|input)',
            r'^.*?Overwriting/deleting this image is not allowed',
            r'^.*?Copying to/from this server name is not permitted'
        ]
        self.CONFIGURE_ERROR_PATTERN = [
            r'^%\s*[Cc]an not open.*',
            r'^%\s*[Nn]ot supported.*',
            r'^%\s*[Ff]ail.*',
            r'^%\s*[Aa]bort.*'
            r'^%\s*[Ee](RROR|rror).*',
        ]
